package compiler;

public class Auxiliary {

  public static String newLine="\r\n";
  public static String newLinePP="\r\n";
  public static String spacePP=" ";

  public static String getPrefix (String wholeName) {
    switch (wholeName.charAt (0)) {
      case 'C':
        return wholeName.substring (0, wholeName.lastIndexOf ("E")+1);
      case 'I':
        return wholeName.substring (0, wholeName.lastIndexOf ("I")+1);
      default:
        return "";
    }
  }

  public static String getName (String wholeName) {
    switch (wholeName.charAt (0)) {
      case 'C':
        return wholeName.substring (wholeName.lastIndexOf ("E")+1);
      case 'I':
        return wholeName.substring (wholeName.lastIndexOf ("I")+1);
      default:
        return wholeName;
    }
  }

  public static int getDataType (CTreeNode node) {
    int i, result;
    CTreeNode additions, record, recordType, tempCTN, tempCTN1;
    VariableEntry recordVar;
    TypeEntry tempTE;

    if (node.dataType==Constants.NONE)
      if (node.symbolNum==sym.NARAVNOSTEVILO)
        node.dataType=Constants.DATA_INT;
      else
        if (node.symbolNum==sym.ABSOLUTNOSTEVILO)
          node.dataType=Constants.DATA_DOUBLE;
        else
          if (node.symbolNum==sym.NIZ)
            if (node.name.length ()>3)
              node.dataType=Constants.DATA_STRING;
            else
              node.dataType=Constants.DATA_CHAR;
          else
            if (node.name.compareTo ("spremenljivka_z_dodatki")==0) {
              record=(CTreeNode)(node.children.elementAt (0));
              recordVar=node.tree.lookupVariable (record.name, node.function);
              recordType=recordVar.type.node;
              node.dataType=getDataType (recordVar.type);
              additions=(CTreeNode)(node.children.elementAt (1));
              for (i=0; i<additions.children.size (); i++) {
                tempCTN=(CTreeNode)(additions.children.elementAt (i));
                if (tempCTN.children.size ()==2) {
                  tempCTN1=(CTreeNode)(tempCTN.children.elementAt (1));
                  if (tempCTN1.symbolNum==sym.IME) {
                    tempTE=getVarTypeByName  (recordType, tempCTN1.name);
                    if (tempTE==null) {
                      while ((recordType.children.size ()>0) && (recordType.symbolNum!=sym.IME))
                        recordType=(CTreeNode)(recordType.children.elementAt (0));
                      tempTE=node.tree.lookupType (recordType, false);
                      recordType=tempTE.node;
                      tempTE=getVarTypeByName  (recordType, tempCTN1.name);
                    }
                    if (tempTE!=null) {
                      node.dataType=getDataType (tempTE);
                      recordType=tempTE.node;
                    }
                  }
                }
              }
            }
            else
              if (node.symbolNum==sym.IME) {
                if ((node.name.compareTo ("Psin")==0) || (node.name.compareTo ("sin")==0))
                  return Constants.DATA_DOUBLE;
                if ((node.name.compareTo ("Pcos")==0) || (node.name.compareTo ("cos")==0))
                  return Constants.DATA_DOUBLE;
                if ((node.name.compareTo ("Pln")==0) || (node.name.compareTo ("log")==0))
                  return Constants.DATA_DOUBLE;
              } else {
                node.dataType=Constants.NONE;
                for (i=0; i<node.children.size (); i++) {
                  tempCTN=(CTreeNode)(node.children.elementAt (i));
                  if (tempCTN.name.compareTo ("vec_izrazov")!=0) {
                    result=getDataType (tempCTN);
                    if ((result==Constants.DATA_INT) && ((node.dataType==Constants.NONE) || (node.dataType==Constants.DATA_INT)))
                      node.dataType=Constants.DATA_INT;
                    if ((result==Constants.DATA_DOUBLE) && ((node.dataType==Constants.NONE) || (node.dataType==Constants.DATA_INT) || (node.dataType==Constants.DATA_DOUBLE)))
                      node.dataType=Constants.DATA_DOUBLE;
                    if ((result==Constants.DATA_CHAR) && (node.dataType==Constants.NONE))
                      node.dataType=Constants.DATA_CHAR;
                    if ((result==Constants.DATA_STRING) && (node.dataType==Constants.NONE))
                      node.dataType=Constants.DATA_STRING;
                  }
                }
              }
    return node.dataType;
  }

  public static int getDataType (TypeEntry type) {
    if ((type.actualType.startsWith ("int")) || (type.actualType.endsWith ("Pinteger")) || (type.actualType.endsWith ("Pboolean")))
      return Constants.DATA_INT;
    if ((type.actualType.startsWith ("double")) || (type.actualType.endsWith ("Preal")))
      return Constants.DATA_DOUBLE;
    if ((type.actualType.startsWith ("char")) || (type.actualType.endsWith ("char")))
      return Constants.DATA_CHAR;
    return Constants.NONE;
  }

  public static TypeEntry getVarTypeByName (CTreeNode node, String name) {
    int i;
    CTreeNode tempCTN;
    TypeEntry tempTE, recursedType;

    if (node.name.startsWith ("zapis"))
      for (i=1; i<node.children.size (); i++) {
        tempCTN=(CTreeNode)(node.children.elementAt (i));
        if (tempCTN.name.compareTo (name)==0) {
          tempTE=node.tree.lookupType ((CTreeNode)(node.children.elementAt (0)), false);
          return tempTE;
        }
      }
    for (i=0; i<node.children.size (); i++) {
      recursedType=getVarTypeByName ((CTreeNode)(node.children.elementAt (i)), name);
      if (recursedType!=null)
        return recursedType;
    }
    return null;
  }
}