package compiler;

import java.util.Vector;

class FunctionEntry {

  public CTreeNode rootNode;
  public String name;
  public TypeEntry type;
  public Vector parameters;
  public Vector variables;

  public FunctionEntry (CTreeNode node) {
    CTreeNode paramNode;

    rootNode=node;
    parameters=new Vector ();
    variables=new Vector ();
    if (node.name.compareTo ("def_funkcije")==0)
      if (node.children.size ()==8)
        type=node.tree.lookupType ((CTreeNode)(node.children.elementAt (4)), true);
      else
        type=node.tree.lookupType ((CTreeNode)(node.children.elementAt (3)), true);
    else
      type=node.tree.lookupType (null, true);
    if (node.name.compareTo ("program")==0)
      name="main";
    else {
      name=node.prefix+((CTreeNode)(node.children.elementAt (1))).name;
      paramNode=(CTreeNode)(node.children.elementAt (2));
      if (paramNode.children.size ()>0)
        ParameterEntry.processParameters ((CTreeNode)(paramNode.children.elementAt (1)), parameters);
    }
  }

  public FunctionEntry (String name1, CTree tree) {
    rootNode=null;
    name=name1;
    type=tree.voidType;
    parameters=new Vector ();
    variables=new Vector ();
  }

  public void unNestFunctions () {
    int i, newParamType;
    ParameterEntry tempPE, newParam;
    VariableEntry tempVE;

    if (rootNode.function!=rootNode.tree.main) {
      for (i=0; i<rootNode.function.variables.size (); i++) {
        tempVE=(VariableEntry)(rootNode.function.variables.elementAt (i));
        newParam=new ParameterEntry ("I"+tempVE.name, tempVE.type, Constants.PARAM_BY_REFERENCE);
        parameters.add (newParam);
      }
      for (i=0; i<rootNode.function.parameters.size (); i++) {
        tempPE=(ParameterEntry)(rootNode.function.parameters.elementAt (i));
        if (tempPE.paramType==Constants.PARAM_BY_VALUE)
          newParamType=Constants.PARAM_BY_REFERENCE;
        else
          newParamType=tempPE.paramType;
        newParam=new ParameterEntry ("I"+tempPE.name, tempPE.type, newParamType);
        parameters.add (newParam);
      }
    }
  }

  public String getHeader () {
    String result="";
    int i;
    ParameterEntry tempPE;

    result+=type+" "+name+" (";
    for (i=0; i<parameters.size (); i++) {
      tempPE=(ParameterEntry)(parameters.elementAt (i));
      result+=tempPE;
      if (i<parameters.size ()-1)
        result+=", ";
    }
    result+=")";
    return result;
  }

  public String getBody () {
    String result="", arrayPart;
    int i;
    CTreeNode tempCTN;
    VariableEntry tempVE;

    if (rootNode.name.compareTo ("def_procedure")==0)
      if (rootNode.children.size ()==6)
        tempCTN=(CTreeNode)(((CTreeNode)(rootNode.children.elementAt (4))).children.elementAt (0));
      else
        tempCTN=(CTreeNode)(((CTreeNode)(rootNode.children.elementAt (3))).children.elementAt (0));
    else
      if (rootNode.children.size ()==8)
        tempCTN=(CTreeNode)(((CTreeNode)(rootNode.children.elementAt (6))).children.elementAt (0));
      else
        tempCTN=(CTreeNode)(((CTreeNode)(rootNode.children.elementAt (5))).children.elementAt (0));
    result+=(CTreeNode)(tempCTN.children.elementAt (0));
    if (name.compareTo ("main")!=0) {
      for (i=0; i<variables.size (); i++) {
        tempVE=(VariableEntry)(variables.elementAt (i));
        arrayPart="";
        if (tempVE.type.type==Constants.TYPE_ARRAY)
          arrayPart=tempVE.type.arrayPart;
        result+=tempVE.type+" "+tempVE.name+" "+arrayPart+";"+Auxiliary.newLine;
      }
      result+=Auxiliary.newLine;
    }
    result+=(CTreeNode)(tempCTN.children.elementAt (1));
    result+=(CTreeNode)(tempCTN.children.elementAt (2));
    return result;
  }
}