package compiler;

import java.util.Vector;

class ParameterEntry {

  String name;
  TypeEntry type;
  int paramType;

  public ParameterEntry (String name1, TypeEntry type1, int paramType1) {
    name=name1;
    type=type1;
    paramType=paramType1;
  }

  public static void processParameters (CTreeNode paramSource, Vector paramDest) {
    int i, j;
    CTreeNode parameter;
    Vector tempVec=new Vector ();
    VariableEntry tempVE;

    for (i=0; i<paramSource.children.size (); i+=2) {
      parameter=(CTreeNode)(((CTreeNode)(paramSource.children.elementAt (i))).children.elementAt (0));
      if (parameter.name.compareTo ("sp_po_vrednosti")==0) {
        VariableEntry.processVariables (parameter, tempVec);
        for (j=0; j<tempVec.size (); j++) {
          tempVE=(VariableEntry)(tempVec.elementAt (j));
          paramDest.add (new ParameterEntry (tempVE.name, tempVE.type, Constants.PARAM_BY_VALUE));
        }
      }
      tempVec.removeAllElements ();
      if (parameter.name.compareTo ("sp_po_referenci")==0) {
        VariableEntry.processVariablesByRef (parameter, tempVec);
        for (j=0; j<tempVec.size (); j++) {
          tempVE=(VariableEntry)(tempVec.elementAt (j));
          paramDest.add (new ParameterEntry (tempVE.name, tempVE.type, Constants.PARAM_BY_REFERENCE));
        }
      }
      tempVec.removeAllElements ();
      if ((parameter.name.compareTo ("sp_procedura")==0) || (parameter.name.compareTo ("sp_funkcija")==0)) {
        VariableEntry.processFunctions (parameter, tempVec);
        for (j=0; j<tempVec.size (); j++) {
          tempVE=(VariableEntry)(tempVec.elementAt (j));
          paramDest.add (new ParameterEntry (tempVE.name, tempVE.type, Constants.PARAM_FUNCTION));
        }
      }
    }
  }

  public String toString () {
    String result;

    result=type+" ";
    if (paramType==Constants.PARAM_BY_REFERENCE)
      result+="*";
    result+=name;
    return result;
  }
}