package compiler;

import java.util.Vector;

class ParseTree {

  private ParseTreeNode root;
  private Vector links;
  private int hLinkCount;

  public int maxLabel;

  public ParseTree () {
    root=null;
    links=new Vector ();
    hLinkCount=0;
    maxLabel=0;
  }

  public void setRoot (ParseTreeNode root1) {
    root=root1;
  }

  public ParseTreeNode getRoot () {
    return root;
  }

  public void addLink (ParseTreeNode node) {
    links.add (node);
  }

  public void addHLink (Vector scopes, ParseTreeNode node) {
    node.hLinkFrom=new Integer (hLinkCount).toString ();
    hLinkCount++;
    ((Vector)(scopes.elementAt (scopes.size ()-1))).add (node);
  }

  public String lookupHLink (Vector scopes, String name) {
    int i, j;
    Vector currentScope;

    for (i=scopes.size ()-1; i>=0; i--) {
      currentScope=(Vector)(scopes.elementAt (i));
      for (j=currentScope.size ()-1; j>=0; j--)
        if (((String)(((ParseTreeNode)(currentScope.elementAt (j))).name)).compareToIgnoreCase (name)==0)
          return ((ParseTreeNode)(currentScope.elementAt (j))).hLinkFrom;
    }
    return "";
  }

  public void print () {
    if (root!=null)
      root.print (0);
  }

  public void print (int lineNum, int charNum) {
    int i;

    for (i=0; i<links.size (); i++)
      if ((((ParseTreeNode)(links.elementAt (i))).lineNum==lineNum) && (((ParseTreeNode)(links.elementAt (i))).charNum==charNum)) {
        ((ParseTreeNode)(links.elementAt (i))).print (0);
        break;
      }
  }

  public void prettyPrint (int tab, boolean align, boolean lowercase, boolean html, boolean links, String cKeyword, String cIdentifier, String cString, String cNumber, String cComment, String cOther) {
    String output;
    char tempC;
    int i;

    if (root!=null) {
      if (html) {
        Classify.cIdentifier=cIdentifier;
        Classify.cKeyword=cKeyword;
        Classify.cString=cString;
        Classify.cNumber=cNumber;
        Classify.cComment=cComment;
        Classify.cOther=cOther;
        ((ParseTreeNode)(root.children.elementAt (6))).hLinks (this, Constants.NONE, new Vector ());
        output=root.prettyPrintFinal (this, tab, align, lowercase, true, links);
        output="<html><body><pre>"+Auxiliary.newLinePP+output+Auxiliary.newLinePP+"</pre></body></html>";
        System.out.println (output);
      } else
        System.out.println (root.prettyPrintFinal (this, tab, align, lowercase, false, links));
    }
  }
}