package compiler;

import java.util.Vector;

class VariableEntry {

  public String name;
  public TypeEntry type;

  public VariableEntry (String name1, CTreeNode type1) {
    name=name1;
    type=type1.tree.lookupType (type1, true);
  }

  public VariableEntry (String name1, TypeEntry type1) {
    name=name1;
    type=type1;
  }

  public static void processVariables (CTreeNode node, Vector varDest) {
    Vector names;
    int i;

    names=((CTreeNode)(node.children.elementAt (0))).children;
    for (i=0; i<names.size (); i+=2)
      varDest.add (new VariableEntry (((CTreeNode)(names.elementAt (i))).name, (CTreeNode)(node.children.elementAt (2))));
  }

  public static void processVariablesByRef (CTreeNode node, Vector varDest) {
    Vector names;
    int i;

    names=((CTreeNode)(node.children.elementAt (1))).children;
    for (i=0; i<names.size (); i+=2)
      varDest.add (new VariableEntry (((CTreeNode)(names.elementAt (i))).name, (CTreeNode)(node.children.elementAt (3))));
  }

  public static void processFunctions (CTreeNode node, Vector varDest) {
    Vector names;
    CTreeNode returnType;
    int i;

    names=((CTreeNode)(node.children.elementAt (1))).children;
    if (node.children.size ()==4)
      returnType=(CTreeNode)(node.children.elementAt (3));
    else
      returnType=null;
    for (i=0; i<names.size (); i+=2)
      varDest.add (new VariableEntry (((CTreeNode)(names.elementAt (i))).name, returnType));
  }
}